
#property copyright "ngm1"

//---- input parameters
extern double    TakeProfit=60.0;
extern double    Lots=1;
extern double    StopLoss=40.0;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }

int Crossed (double lineA_curr , double lineA_prev, double lineB_curr , double lineB_prev )
   {      
      static int current_direction = 0;
      
      if((lineA_curr>=lineB_curr && lineA_prev<lineB_prev) || (lineA_curr>lineB_curr && lineA_prev<=lineB_prev)) 
         {
            current_direction = 1; //up
         }
      else 
         {
            if((lineA_curr<=lineB_curr && lineA_prev>lineB_prev) || (lineA_curr<lineB_curr && lineA_prev>=lineB_prev)) 
               {
                  current_direction = -1; //down
               }
            else
               {
                  current_direction = 0;
               }
            
         }
        return (current_direction);

   } 
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//---- 

   
   int cnt, ticket, total;
   double shortEma, longEma;
   double MacdLive, MacdLast, MacdLast2, MacdSignalLive, MacdSignalLast, MacdSignalLast2;
   double StochLive, StochLast, StochLast2, StochSignalLive, StochSignalLast, StochSignalLast2;

   

     
   MacdLive=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,0);
   MacdLast=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,1);
   MacdLast2=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,2);
   MacdSignalLive=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,0);
   MacdSignalLast=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,1);
   MacdSignalLast2=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,2);

   StochLive = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,0);
   StochLast = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,1);
   StochLast2 = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,2);
   StochSignalLive = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_SIGNAL,0);
   StochSignalLast = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_SIGNAL,1);
   StochSignalLast2 = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_SIGNAL,2);
  
   int isCrossed  = Crossed (MacdLast,MacdLast2,MacdSignalLast,MacdSignalLast2);
   //int isCrossedStoch  = Crossed (StochLast,StochSignalLast);
   
   Print(isCrossed," MACD");
   //Print(isCrossedStoch, "STOCH");
   
   total  = OrdersTotal(); 
   
   //position checks first; any need to exit existing position because of trend change?
   
     
   
   //if(total < 1) 
   //  {
       if(isCrossed == 1)
         {
            ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,1,Ask-StopLoss*Point,Ask+TakeProfit*Point,"New Buy",12345,0,Green);
            //ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,1,0,0,"New Buy",12345,0,Green);
            Print("BUY SIGNAL - px = ", Ask);
            if(ticket>0)
              {
               if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
              }
            else Print("Error opening BUY order : ",GetLastError()); 
            return(0);
         }
         if(isCrossed == -1)
         {
            ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,1,Bid+StopLoss*Point,Bid-TakeProfit*Point,"New Sell",12345,0,Red);
            //ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,1,0,0,"New Sell",12345,0,Red);
            Print("SELL SIGNAL - px = ", Bid);
            if(ticket>0)
              {
               if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
              }
            else Print("Error opening SELL order : ",GetLastError()); 
            return(0);
         }         
   //  }
   
  return(0);
   }
//+------------------------------------------------------------------+